

#ifndef KX022_h
#define KX022_h

#define KX022_ADDRESS 0x1E  // 0x1F if ADDR is high, 0x1E if low

//Define a few of the registers that we will be accessing on the KX022
#define XOUT_L         0x06
#define WHO_AM_I      0x0F
#define CNTL1         0x18
  //bit7(PC1):   0=stand-by mode, 1:operating mode
  //bit6(RES):   0=low current, 1:High current.Bandwidth=ODR/2
  //bit5(DRDUE): 0=availability of new acceleration data is not reflected as an interrupt
  //bit4,3(GSEL1,0): 00=2g, 01=4g, 10=8g
  //bit2(WUFE):  Wake up function 0=Disable
  //bit1(TPE):   Tilt Position function 0=Disable
#define CNTL3         0x1A
#define ODCNTL        0x1B

#define HIGHCURRENT 1 //0=Low current mode (8bit ADC), 1=High current mode(16bit ADC)
#define GSCALE 2 // Sets full-scale range to +/-2, 4, or 8g. Used to calc real g values.

bool initKX022();
void readAccelData(float *);
void readRegisters(byte , int , byte * );
byte readRegister(byte);
void writeRegister(byte , byte );
void KX022Standby();
void KX022Active();

#endif //MMA8452Q_h
