﻿/*GR-CARRY Sketch Template Version: E0.10*/
#include <Arduino.h>
#include "KX022.h"
//#include "CapacitiveSensor.h"

#define FULLFULL_NUM 7  //0 to 7

// Pin 11,12,13 are assigned to RGB LEDs.
int led_r = 11; // LOW active
int led_g = 12; // LOW active
int led_b = 13; // LOW active
unsigned int colorCnt;

// the setup routine runs once when you press reset:
void setup() {
	//setPowerManagementMode(PM_SNOOZE_MODE, 0, 1000); //Set CPU SNOOZE in analogRead()
	//setOperationClockMode(CLK_LOW_SPEED_MODE); //Set CPU clock from 32MHz to 32.768kHz

	// initialize the digital pin as an output.
	pinMode(led_r, OUTPUT);
	pinMode(led_g, OUTPUT);
	pinMode(led_b, OUTPUT);
	// turn the LEDs off.
	digitalWrite(led_r, HIGH);
	digitalWrite(led_g, HIGH);
	digitalWrite(led_b, HIGH);
	// for touch sensing.
	pinMode(19, OUTPUT);
	digitalWrite(19, HIGH);

	Serial.begin(115200);
	Serial.println("CARRY FULL FULL!! (^o^)/");
  
	Serial.print("Temperature:\t");
	Serial.println(getTemperature(TEMP_MODE_CELSIUS)); //temperature from the sensor in MCU

	if (initKX022() == true) {
		Serial.println("initKX022 OK");
	} else {
		Serial.println("initKX022 NG");
		digitalWrite(led_r, LOW);
		while(1);
	}
	colorCnt = 0;
}

// the loop routine runs over and over again forever:
void loop() {
	float accdata[3];
	float fullfull;
	int touchSense;

	readAccelData(accdata);
	if (accdata[0] < 0)		accdata[0] = -accdata[0]; // x
	if (accdata[1] < 0)		accdata[1] = -accdata[1]; // y
	if (accdata[2] < 0)		accdata[2] = -accdata[2]; // z
	fullfull = accdata[0] + accdata[1] + accdata[2];
	touchSense = analogRead(A4);

	if ((fullfull > 2) | (touchSense < 900)) {
		Serial.print(touchSense);
		Serial.print("\t");
		Serial.println(fullfull);
		switch(FULLFULL_NUM){
			case 0: //red
				digitalWrite(led_r, LOW);
				digitalWrite(led_g, HIGH);
				digitalWrite(led_b, HIGH);
				break;
			case 1: //green
				digitalWrite(led_r, HIGH);
				digitalWrite(led_g, LOW);
				digitalWrite(led_b, HIGH);
				break;
			case 2: //blue
				digitalWrite(led_r, HIGH);
				digitalWrite(led_g, HIGH);
				digitalWrite(led_b, LOW);
				break;
			case 3: //yellow
				digitalWrite(led_r, LOW);
				digitalWrite(led_g, LOW);
				digitalWrite(led_b, HIGH);
				break;
			case 4: //pink
				digitalWrite(led_r, LOW);
				digitalWrite(led_g, HIGH);
				digitalWrite(led_b, LOW);
				break;
			case 5: //sky blue
				digitalWrite(led_r, HIGH);
				digitalWrite(led_g, LOW);
				digitalWrite(led_b, LOW);
				break;
			case 6: //white
				digitalWrite(led_r, LOW);
				digitalWrite(led_g, LOW);
				digitalWrite(led_b, LOW);
				break;
			case 7: //rainbow
				switch(colorCnt){
					case 0: //red
						digitalWrite(led_r, LOW);
						digitalWrite(led_g, HIGH);
						digitalWrite(led_b, HIGH);
						colorCnt++;
						break;
					case 1: //pink
						digitalWrite(led_r, LOW);
						digitalWrite(led_g, HIGH);
						digitalWrite(led_b, LOW);
						colorCnt++;
						break;
					case 2: //blue
						digitalWrite(led_r, HIGH);
						digitalWrite(led_g, HIGH);
						digitalWrite(led_b, LOW);
						colorCnt++;
						break;
					case 3: //sky blue
						digitalWrite(led_r, HIGH);
						digitalWrite(led_g, LOW);
						digitalWrite(led_b, LOW);
						colorCnt++;
						break;
					case 4: //green
						digitalWrite(led_r, HIGH);
						digitalWrite(led_g, LOW);
						digitalWrite(led_b, HIGH);
						colorCnt++;
						break;
					case 5: //yellow
						digitalWrite(led_r, LOW);
						digitalWrite(led_g, LOW);
						digitalWrite(led_b, HIGH);
						colorCnt++;
						break;
					case 6: //white
						digitalWrite(led_r, LOW);
						digitalWrite(led_g, LOW);
						digitalWrite(led_b, LOW);
						colorCnt = 0;
						break;
				}
				break;
			default : //OFF
				digitalWrite(led_r, HIGH);
				digitalWrite(led_g, HIGH);
				digitalWrite(led_b, HIGH);
				break;
		}
		delay(100);
	}
	else {
		//off
		digitalWrite(led_r, HIGH);   // turn the RED LED off
		digitalWrite(led_g, HIGH); // turn the GREEN LED off
		digitalWrite(led_b, HIGH);  // turn the BLUE LED off
	}

}
